/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 234 - (show annotations)
Sat Jan 22 16:07:46 2011 UTC (13 years, 2 months ago) by dpavlin
File MIME type: application/x-sh
File size: 5487 byte(s)
remote checkroot.sh used by squeeze
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43 lxc_hostname() {
44 inside=`cat $(lxc_rootfs $1)/etc/hostname`
45 config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46 echo "$config [$inside]";
47 }
48
49 lxc_ip() {
50 ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 || \
51 grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //' ) | \
52 sed -e 's/ *//g' -e 's/\/.*$//'
53 }
54
55 lxc_status() {
56 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
57 boot="-"
58 test -s /var/lib/lxc/$name/on_boot && boot="boot"
59 echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
60 done ) | column -t
61 }
62
63
64 cleanup_init_scripts() {
65 rootfs=$(lxc_rootfs $1)
66
67 ls \
68 $rootfs/etc/rc?.d/*checkroot* \
69 $rootfs/etc/rc?.d/*umountfs \
70 $rootfs/etc/rc?.d/*umountroot \
71 $rootfs/etc/rc?.d/*hwclock* \
72 $rootfs/etc/rc?.d/*udev* \
73 2>/dev/null | xargs -i rm -v {}
74
75 echo $1 > $rootfs/etc/hostname
76 grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
77 }
78
79
80 setup_inittab() {
81 rootfs=$(lxc_rootfs $1)
82 remove=$2
83 add=$3
84
85 # let container respond to kill -SIGPWR
86 inittab=$rootfs/etc/inittab
87 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
88 grep -v "$remove" ${inittab} > ${inittab}.new
89 echo $add >> ${inittab}.new
90 mv ${inittab}.new ${inittab}
91 echo "$inittab modified with $add"
92 fi
93 }
94
95
96 lxc_log() {
97 echo `date +%Y-%m-%dT%H:%M:%S` $*
98 }
99
100
101 lxc_kill() {
102 name=$1
103 sig=$2
104
105 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
106 if [ -z "$init_pid" ] ; then
107 lxc-info -n $name
108 exit 1
109 fi
110 lxc_log "$name kill $sig $init_pid"
111 /bin/kill $sig $init_pid
112 }
113
114 lxc_stop() {
115 lxc_log "$name stop"
116 lxc_kill $name -SIGPWR
117 lxc-wait -n $name -s STOPPED
118 lxc_log "$name stoped"
119 # rm -f /var/lib/lxc/${name}/on_boot
120 }
121
122
123 lxc_start() {
124 name=$1
125 rootfs=$(lxc_rootfs $1)
126
127 if [ ! -e $rootfs ] ; then
128 echo "ERROR $name rootfs $rootfs not found"
129 return
130 fi
131
132 if ! lxc-info -n $name | grep RUNNING ; then
133 lxc_log "$name start"
134 lxc-start -n $name -o /tmp/${name}.log -d
135 lxc-wait -n $name -s RUNNING
136 lxc-info -n $name
137 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
138 fi
139 }
140
141 lxc_watchdog() {
142 name=$1
143 rootfs=$(lxc_rootfs $1)
144
145 while true; do
146 vps_utmp=${rootfs}/var/run/utmp
147 tasks=`wc -l < /cgroup/${name}/tasks`
148 test -z "$tasks" && exit 1
149 if [ "$tasks" -eq 1 ]; then
150
151 runlevel="$(runlevel ${vps_utmp})"
152 lxc_log "$name runlevel $runlevel"
153
154 case $runlevel in
155 N*)
156 # nothing for new boot state
157 ;;
158 ??0)
159 lxc_log "$name halt"
160 lxc-stop -n "${name}"
161 lxc-wait -n ${name} -s STOPPED
162 break
163 ;;
164 ??6)
165 lxc_log "$name reboot";
166 lxc-stop -n ${name}
167 lxc-wait -n ${name} -s STOPPED
168 lxc-start -d -n ${name} -o /tmp/${name}.log
169 ;;
170 *)
171 # make sure vps is still running
172 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
173 [ "$state" = "RUNNING" ] || break
174 ;;
175 esac
176 else
177 lxc_log "$name $tasks tasks"
178 fi
179
180 # time of 5 minutes on it JUST IN CASE...
181 inotifywait -qqt 300 ${vps_utmp}
182 done
183
184 lxc_log "$name watchdog exited"
185
186 }
187
188
189 usage() {
190 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
191 exit 3
192 }
193
194 command_on_lxc() {
195 command=$1
196 shift
197
198 echo "# $command $1"
199
200 case "$command" in
201
202 start)
203 lxc_exists $1
204 cleanup_init_scripts $1
205 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
206 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
207 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
208 lxc_start $1
209 # give container 5 seconds to start more than one process
210 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
211 ;;
212 stop|halt)
213 lxc_exists $1
214 lxc_stop $1
215 ;;
216 reload|force-reload|restart|reboot)
217 lxc_kill $1 -SIGINT
218 ;;
219 watchdog)
220 lxc_watchdog $1
221 ;;
222 boot)
223 echo $1 > /var/lib/lxc/$1/on_boot
224 ;;
225 disable)
226 echo -n > /var/lib/lxc/$1/on_boot
227 ;;
228 *)
229 usage
230 ;;
231
232 esac
233
234 }
235
236 command=$1
237 test -z "$command" && usage
238 test "$command" = "status" && lxc_status && exit
239 shift
240
241 if [ -z "$1" ] ; then
242 ls /var/lib/lxc/*/on_boot | while read path ; do
243 name=`echo $path | cut -d/ -f5`
244 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
245 command_on_lxc $command $name
246 else
247 echo "# skip $command $name"
248 fi
249 done
250 else
251 while [ ! -z "$1" ] ; do
252 command_on_lxc $command $1
253 shift
254 done
255 fi
256

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26